;===========================================================
;
;     Redirection Test Program for Windows 95
;     07-05-95 Sven B. Schreiber, sbs@psbs.franken.de
;
;     Use MASM 6.xx to assemble:
;
;     ml /I. /Zm /c /Fotest.obj /Flnul.lst /FR /Ta test.asm
;     link test;
;     exe2bin test test.com
;
;===========================================================
;
BASE              equ   0100h    ;program base address
;
DOS               equ   21h      ;dos api
;
DOS_OUTPUT        equ   02h      ;display character
DOS_READ          equ   3Fh      ;read file
DOS_TERMINATE     equ   4Ch      ;terminate program
;
STDIN             equ   0        ;standard input handle
;
;===========================================================
;
_text       segment
            assume cs:_text, ds:_text, es:_text, ss:_text
            org    BASE
;
Start:
      jmp   Main                 ;start program
      dw    FreeMemory           ;first unused address
;
;===========================================================
;
;      no parameters
;
;-----------------------------------------------------------
;
Main:
      call  CopyData             ;copy data
      mov   al,0                 ;terminate program
      mov   ah,DOS_TERMINATE
      int   DOS
;
;===========================================================
;
;      <     c  -  set if error
;
;-----------------------------------------------------------
;
CopyData:
      mov   bx,offset STDIN      ;read data block from stdin
      mov   cx,offset DataBuffer_
      mov   dx,offset DataBuffer
      mov   ah,DOS_READ
      int   DOS
      jb    CopyData2            ;c = error
      mov   cx,ax
      jcxz  CopyData2            ;nc = ok
      mov   si,offset DataBuffer ;process data
CopyData1:
      push  cx
      push  si
      mov   dl,byte ptr [si]     ;display data byte
      mov   ah,DOS_OUTPUT
      int   DOS
      pop   si
      pop   cx
      inc   si                   ;next data byte
      loop  CopyData1
      jmp   CopyData             ;repeat until eof
CopyData2:
      ret
;
;===========================================================
;
DataBuffer_ equ   8              ;data buffer size
DataBuffer  equ   $              ;data buffer
;
FreeMemory  equ   $ + DataBuffer_
;
;===========================================================
;
_text       ends
            end   Start



